/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.payroll.bonus.action;

import jp.mosp.payroll.base.PayrollAction;
import jp.mosp.payroll.bonus.vo.BonusCalcVo;
import jp.mosp.payroll.bonus.vo.BonusCardVo;


import jp.mosp.payroll.bonus.BonusConst;

import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;

/**
 * 給与明細出力機能を提供する。<br><br>
 * 給与計算画面から、年月を指定して対象全員分の給与明細を一括出力する。<br>
 * また給与明細画面から、選択社員の選択年月における給与明細を出力する。<br>
 */
public class BonusDetailAction extends PayrollAction {
	
	// コマンド
	private static final String CMD_BONUS_DETAIL_ALL = "P2031";
	private static final String CMD_BONUS_DETAIL_ONE = "P2032";
	
	// テンプレートXMLファイルパス
//	private static final String template = "/template/bonusDetail.jasper";
	
	/**
	 * コンストラクタ。<br>
	 * 処理シーケンス発行不要設定を行う。<br>
	 */
	public BonusDetailAction() {
		super();
		setNeedProcSeq(false);
	}
	
	/**
	 * 賞与明細を出力する。<br>
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// PAYROLL権限確認
		if (cmd.equals(CMD_BONUS_DETAIL_ALL)) {
			// VOの取得
			BonusCalcVo vo = (BonusCalcVo)session.getAttribute(MospConst.ATT_FORMER_VO);
			vo.clearMessage();
			vo.clearErrField();
			vo.initVo(cfg, msg, cmd, aspUser, user);
			// パラメータ取得
			vo.setYearParams(request);
			// 帳票作成準備
			String fileName = vo.getPltDetailYear () + BonusConst.FILE_NAME_SEPARATOR
							+ vo.getPltDetailMonth() + BonusConst.FILE_NAME_SEPARATOR
							+ vo.getPltDetailDay() + BonusConst.FILE_NAME_SEPARATOR
							+ BonusConst.FILE_BONUS_DETAIL;
			request.setAttribute(MospConst.ATT_FILE_NAME, fileName);
			// 帳票作成及び設定
		} else if (cmd.equals(CMD_BONUS_DETAIL_ONE)) {
			// VOの取得
			BonusCardVo vo = new BonusCardVo();
			vo = (BonusCardVo)getStoredVo(vo.getClassName());
			vo.clearMessage();
			vo.clearErrField();
			vo.initVo(cfg, msg, cmd, aspUser, user);
			// パラメータ取得
			vo.setParams(request);
			// 帳票作成準備
			String fileName = vo.getPltYear () + BonusConst.FILE_NAME_SEPARATOR
							+ vo.getPltMonth() + BonusConst.FILE_NAME_SEPARATOR
							+ vo.getPltDay() + BonusConst.FILE_NAME_SEPARATOR
							+ vo.getHidKCode()       + BonusConst.FILE_NAME_SEPARATOR
							+ BonusConst.FILE_BONUS_DETAIL;
			request.setAttribute(MospConst.ATT_FILE_NAME, fileName);
			// 帳票作成及び設定
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
}
	
	/**
	 * PDF帳票を作成する。<br>
	 * @param template テンプレートファイルパス
	 * @param list     出力対象リスト
	 * @return PDF出力オブジェクト
	 * @throws MospException
	 */
/**
	private JRExporter print(
			String template, List<BonusDetailDto> list
	) throws MospException {
		try {
			// 動的バインドデータ準備
			JRBeanCollectionDataSource ds = new JRBeanCollectionDataSource(list);
			// 帳票作成
			JasperPrint print = JasperFillManager.fillReport(template, new HashMap(), ds);
			// PDF出力準備
			JRPdfExporter exporter = new JRPdfExporter();
			exporter.setParameter(JRExporterParameter.JASPER_PRINT, print);
			return exporter;
		} catch (JRException e) {
			throw new MospException(BonusConst.EX_PRINT_FAILED, MospUtility.getStackTrace(e));
		}
	}
}
*/
